%{
extern int cptline;

int getRegR(char *in){
    char k[3];
    k[0]=in[1];
    k[1]=in[2];
    k[2]=0;
    return atoi(k);
}

int getRegReg(char *in){
    char k[3];
    k[0]=in[3];
    k[1]=in[4];
    k[2]=0;
    return atoi(k);
}
%}

%s NORM COMM

%%
%{
    BEGIN NORM;
%}
<NORM>[ \t]
<NORM>\n	{	cptline++; }
<NORM>\;	BEGIN COMM;

<COMM>\n	{BEGIN NORM;cptline++;}
<COMM>[^\n]	;

<NORM>.core1	{yylval.dir=1;return(Core);}
<NORM>.core2	{yylval.dir=2;return(Core);}
<NORM>.core3	{yylval.dir=3;return(Core);}

<NORM>.data	{return(Data);}
<NORM>.text	{return(Text);}
<NORM>.stack	{return(Stack);}

<NORM>.byte	{return(Byte);}
<NORM>.word	{return(Word);}

<NORM>mvA	{yylval.inst=mvA;return(Inst);}/* Instructions for all of the cores */
<NORM>coA	{yylval.inst=coA;return(Inst);}
<NORM>mvB	{yylval.inst=mvB;return(Inst);}
<NORM>coB	{yylval.inst=coB;return(Inst);}
<NORM>shl	{yylval.inst=shl;return(Inst);}
<NORM>shr	{yylval.inst=shr;return(Inst);}
<NORM>and	{yylval.inst=and;return(Inst);}
<NORM>orr	{yylval.inst=orr;return(Inst);}
<NORM>xor	{yylval.inst=xor;return(Inst);}
<NORM>add	{yylval.inst=add;return(Inst);}
<NORM>sub	{yylval.inst=sub;return(Inst);}
<NORM>jmp	{yylval.inst=jmp;return(Inst);}

<NORM>mvD	{yylval.inst=mvD;return(Inst);}//Instructions for cores >ver2
<NORM>Fmv	{yylval.inst=Fmv;return(Inst);}
<NORM>Dmv	{yylval.inst=Dmv;return(Inst);}
<NORM>mvP	{yylval.inst=mvP;return(Inst);}

<NORM>csB	{yylval.inst=csB;return(Inst);}//Instructions for cores >ver2

<NORM>int	{yylval.inst=iint;return(Inst);}//Instructions for cores ver3
<NORM>ire	{yylval.inst=ire;return(Inst);}
<NORM>Imv	{yylval.inst=Imv;return(Inst);}

<NORM>cal	{yylval.inst=cal;return(Inst);}//Instructions for cores ver2
<NORM>ret	{yylval.inst=ret;return(Inst);}

<NORM>pus	{yylval.inst=pus;return(Mac);}//Macro push on the stack
<NORM>pop	{yylval.inst=pop;return(Mac);}//Macro pop from the stack
<NORM>top	{yylval.inst=pop;return(Mac);}//Macro top of the stack

<NORM>$[0-9][0-5]*	{yylval.reg=getRegR(yytext);return(Reg);}//Registers
<NORM>reg[0-9][0-5]*	{yylval.reg=getRegReg(yytext);return(Reg);}
<NORM>r[0-9][0-5]*	{yylval.reg=getRegR(yytext);return(Reg);}
<NORM>DPorig		{yylval.reg=8;return(Reg);}
<NORM>tmp1		{yylval.reg=9;return(Reg);}
<NORM>tmp2		{yylval.reg=10;return(Reg);}
<NORM>ireA		{yylval.reg=11;return(Reg);}
<NORM>FLAG		{yylval.reg=12;return(Reg);}
<NORM>mem		{yylval.reg=13;return(Reg);}
<NORM>DP		{yylval.reg=14;return(Reg);}
<NORM>IP		{yylval.reg=15;return(Reg);}
<NORM>[a-z][a-z0-9]*:	{yylval.label=yytext;return(Label);}

<NORM>[0-9]*		{yylval.cons=atoi(yytext);return(Cons);}
<NORM>,[0-9]*		{yylval.cons=atoi(yytext);return(Cons);}

<NORM>','		{return(',');}

%%
/*
<NORM>.dword	{return(Dword);}
<NORM>.qword	{return(Qword);}
*/