//STEFAN, Istvan
//Little endian???
//published under GPL
//Mukodik:
//	utasitasok, regiszterek, direktivak felismerese
//	kovetkezo direktivaknal szam felismerese:
//		.byte,.word,.dword,.qword,.ascii,.asciiz
//		nincs szohatarhoz igazitva az adatsor vege sem eleje
//	nincs kezelve, szukseges?:
//		.nibble,.bool,.space!!!Ez kellene
//		.stack:verem meretenek beallitasa
//	todo:
//		stack meretenek olvasasa
//		hexa szamok felismerese (boolean, octa?)
//		szohatarhoz igazitas
//		kimeneti fajlformatum:
//			szekciok meretenek kiirasa
//			!!eddig nem tud futni a sim
//		a sorszamok helyes szamolasa

#include <stdio.h>
#include <string.h>//strcmp(),strcpy()
#include <stdlib.h>//atoll()

#include "labels.h"

//Debugging
int debug=0;
//Line number
int cptline=0;
//Version of the core
int version=1;;
//File descriptors
    FILE * f;//Input file
    FILE * d;//Data section,temporary
    FILE * t;//Text section,temporary
    FILE * o;//Output file
    FILE * yyin;//Input file for yacc
//Till now ready for lex/yacc

//Directive's names
#define MAXDIR 12
char *dire[MAXDIR+1]={".data",".stack",".text",".core3",".byte",".word",".dword",
		".qword",".ascii",".asciiz",".space",".core2",""};

int dorg=0,torg=0;//Global vars, place actual in the section .data/.text
int stackl=0;
char datab=0,stackb=0,textb=0;//These directives can be declared only one time
    //0:not yet defined,1:defined,2:actual section
/*
struct labstruct{
    char name[15];
    unsigned int address;
    unsigned char label_type;//0:address not defined,1:data label,2:text label 
};

//Storing the labels
struct labstruct lab[100];
int maxlab=0;//Current number of labels
*/
//Structure of the binary file:
//	address of main function (unsigned int)
//	length of stack section (unsigned int)
//		???length of the next section (unsigned int)
//	.data section
//		//0x0000:the adress of the stack at runtime->deleted
//		label's pointers
//		initialised datas
//		???length of the next section (unsigned int)
//	.text section
//		???length of the next section (unsigned int){0}
//	???chksum???
//Structure on execution:
//	.text segment
//	.data segment:
//		address of stack?->deleted
//	.stack
//Structure of the data section at the runtime
//	0x0 address of the stack
//	0x1 addresses of the labels (functions, variables, etc)

int wordsize=32;//This is the width of the registers and granulity of the .data

int htu(char *c){
    printf("Asm compiler for the nCore project at opencores.org\n");
    printf("Published under the GPL.\n");
    printf("\tUse:\n");
    printf("\t%s infile.asm [outfile]\n",c);
    return(0);
}

#undef debug
/*
int newlabel(char * s){//Add the label name s to the list of labels(w/o address)
    int i=0;
    while(((i<maxlab)&(strcmp(lab[i].name,s)!=0)))
	i++;
    if(i<maxlab)
	return(-1);//The label already exist, we can't overwrite it
    strcpy(lab[maxlab].name,s);
    lab[maxlab].address=0;
    lab[maxlab].label_type=0;//'Not yet used' label
    maxlab++;
    return(i);//i=maxlab-1
}

int findlabel(char * s){//Search the label s in the label's list
    int i=0;
    while(((i<maxlab)&(strcmp(lab[i].name,s)!=0)))
	i++;
    if(i==maxlab)
	return(-1);//The label not exist
    return(i);
}

//#define debug
int addlabel(char * s){//Add the address to the existing label s
    int i=0;
    while(((i<maxlab)&(strcmp(lab[i].name,s)!=0)))
    	i++;
    if(datab==2){
	lab[i].address=dorg;
	lab[i].label_type=1;//Label under use, pointing to data
	return(i);
	}
    else if(textb==2){
	lab[i].address=torg;
	lab[i].label_type=2;//Label under use, pointing to function
#ifdef debug
	printf("Marked label at %d:%d\n",torg,lab[i].address);
#endif
	return(i);
	}
    else return(-2);//We can't define a label out of the .data/.text sections
}
*/
#undef debug

//Egyszeres forditas:
//	a cimkek tablazatat a .data elejere kiirjuk, igy nem valtozik
//	a kod a cimkektol fuggoen
//	cimkere valo hivatkozaskor nem a cimke cimet olvassuk be, hanem
//	a .data elejenek cimehez adjuk hozza a cimke sorszamat, onnan
//	olvassuk be a cimke cimet->athelyezhetoek akar futas kozben is!!!
//	(feltetel: minden olvasas es iras elott be kell olvasni a cimet,
//	valamint/illetve csak kooperativ taszk eseten, mert preemptiv
//	eseten a betoltes utan is athelyezodhet a kod-vagy csak bizonyos
//	rendszerhivas eseten helyezodjon at)
//	ha nem athelyezheto, gyorsabb, mert kevesebb a konstans
//Jo lenne az elf formatum:
//	kovetelmeny a 32 bit
#undef debug
#define debug

int main(int arg,char **argv){
    int cer;
    int i;
    int m=0;//Is the __main defined?
    char chartmp;
    if(arg==1){
	htu(argv[0]);
	return(0);
    }

    if(arg>=2){//There's an input file
	if(!(f=fopen(argv[1],"ro"))){
	    printf("Error opening the input file\n");
	    return(-1);
	}
    }

    if(arg==3){//There's an output file
	if(!(o=fopen(argv[2],"w+"))){
	    printf("Error opening the output file '%s\n'\n",argv[2]);
	    return(-1);
	}
    }else
	if(!(o=fopen("out","w+"))){
	    printf("Error opening the output file 'out'\n");
	    return(-1);
	}

    d=tmpfile();//Temp file to store the informations about the .data section
    t=tmpfile();//Temp file to store the informations about the .text section

    cptline=0;
    yyin=f;
    
    yyparse();
    
    fclose(yyin);
//Creating the output file
//Writing out the version of the used instruction set
	fprintf(o,"%c%c%c%c",(version & 0xFF),
			(version>>8)& 0xFF,
			(version>>16)& 0xFF,
			(version>>24));//Little endian
//Address of the __main function, verifing the labels
for(i=0;i<maxlab;i++){//->while
    if(strcmp(lab[i].name,"__main")==0){
#ifdef debug
	printf("__main found:%d::%d,%d\n",lab[i].address,(lab[i].address & 0xFF),lab[i].address>>8);
#endif
//Big or little endian?
//	fprintf(o,"%c%c",(lab[i].address & 0xFF),lab[i].address>>8);//Little
//	fprintf(o,"%c%c",lab[i].address>>8,(lab[i].address & 255));//Big
//	//Big or little endian?32 bit
	fprintf(o,"%c%c%c%c",(lab[i].address & 0xFF),
			(lab[i].address>>8)& 0xFF,
			(lab[i].address>>16)& 0xFF,
			(lab[i].address>>24));//Little
////	fprintf(o,"%c%c%c%c",lab[i].address>>24,
//			(lab[i].address>>16)& 0xFF,
//			(lab[i].address>>8)& 0xFF,
//			(lab[i].address & 255));//Big
	m=1;
	}

    if(lab[i].label_type==0){
	printf("Error:\nThe following label is not defined but used:%s\n"
	    ,lab[i].name);
	fclose(d);
	fclose(t);
//	fclose(f);
	fclose(o);
	remove("out");
	return(-1);
	}
#ifdef debug
    else{
	printf("Label:%s,position at %d\n",lab[i].name,lab[i].address);
	}
#endif
    }

if(m==0)//If there's no main function, we begin at the start of the code
//    fprintf(o,"%c%c",0,0);//16 bit address
    fprintf(o,"%c%c%c%c",0,0,0,0);//32 bit address

#ifdef debug
    printf("Length of the .stack section:%d\n",stackl);
#endif
//Writing the length of the stack section
	fprintf(o,"%c%c%c%c",(stackl & 0xFF),
			(stackl>>8)& 0xFF,
			(stackl>>16)& 0xFF,
			(stackl>>24));//Little endian

//Writing the length of the next (.data) section
//That's equ:dorg+no of labels!
dorg+=maxlab;
#ifdef debug
    printf("Length of the .data section:%d\n",dorg);
#endif
	fprintf(o,"%c%c%c%c",(dorg & 0xFF),
			(dorg>>8)& 0xFF,
			(dorg>>16)& 0xFF,
			(dorg>>24));//Little endian

//Writing out the labels
for(i=0;i<maxlab;i++){
    if(lab[i].label_type==1)
	lab[i].address+=maxlab;
//    lab[i].address+=1;//+address of the stack at runtime->deleted, done at ini
	//Big or little endian?
//	fprintf(o,"%c%c",(lab[i].address & 0xFF),lab[i].address>>8);//Little
//	fprintf(o,"%c%c",lab[i].address>>8,(lab[i].address & 255));//Big
//	//Big or little endian?32 bit
	fprintf(o,"%c%c%c%c",(lab[i].address & 0xFF),
			(lab[i].address>>8)& 0xFF,
			(lab[i].address>>16)& 0xFF,
			(lab[i].address>>24));//Little
	printf("%d:%d,%d,%d,%d;%d\n",i,(lab[i].address & 0xFF),
			(lab[i].address>>8)& 0xFF,
			(lab[i].address>>16)& 0xFF,
			(lab[i].address>>24),lab[i].address);//Little
////	fprintf(o,"%c%c%c%c",lab[i].address>>24,
//			(lab[i].address>>16)& 0xFF,
//			(lab[i].address>>8)& 0xFF,
//			(lab[i].address & 255));//Big
    }

rewind(d);//Writing the rest of the data section
while(!feof(d)){
    chartmp=fgetc(d);
    if(!feof(d))
	fputc(chartmp,o);
	}
#ifdef debug
    printf("Length of the .text section:%d\n",torg);
#endif
//Writing the length of the next (.text) section
	fprintf(o,"%c%c%c%c",(torg & 0xFF),
			(torg>>8)& 0xFF,
			(torg>>16)& 0xFF,
			(torg>>24));//Little endian

//	printf("%d,%d,%d,%d\n",(torg & 0xFF),
//			(torg>>8)& 0xFF,
//			(torg>>16)& 0xFF,
//			(torg>>24));//Little endian
//
rewind(t);//Writing the text section
while(!feof(t)){
    chartmp=fgetc(t);
    if(!feof(t))
	fputc(chartmp,o);
	}
//while(!feof(t))->to del
//    fputc(fgetc(t),o);

    fclose(d);
    fclose(t);
//    fclose(f);
    fclose(o);
    return 0;
}
