#include <stdio.h>
#include "labels.h"
#include "core.h"

void getMac(int inst,int reg);

void getInst(int inst,int reg){
//printf("getInst%d,%d,%d,%d\n",inst,reg,version,mvA);
switch(version){
    case 1:
	switch(inst){
	//Normal instructions
	case coA: fputc((0<<4)+reg,t);break;
	case coB: fputc((1<<4)+reg,t);break;
	case add: fputc((2<<4)+reg,t);break;
	case sub: fputc((3<<4)+reg,t);break;
	case mvA: fputc((4<<4)+reg,t);break;
	case mvB: fputc((5<<4)+reg,t);break;
	case shl: fputc((6<<4)+reg,t);break;
	case shr: fputc((7<<4)+reg,t);break;
	case and: fputc((8<<4)+reg,t);break;
	case orr: fputc((9<<4)+reg,t);break;
	case xor: fputc((10<<4)+reg,t);break;
	case jmp: fputc((11<<4)+reg,t);break;
	case Fmv: fputc((12<<4)+reg,t);break;
	case mvD: fputc((13<<4)+reg,t);break;
	case Dmv: fputc((14<<4)+reg,t);break;
	case mvP: fputc((15<<4)+reg,t);break;
	default: exit(-1);
	}break;
    case 2:
	switch(inst){
	//Normal instructions
	case mvA: fputc((0<<4)+reg,t);break;
	case coA: fputc((1<<4)+reg,t);break;
	case mvB: fputc((2<<4)+reg,t);break;
	case coB: fputc((3<<4)+reg,t);break;
	case csB: fputc((4<<4)+reg,t);break;
	case shl: fputc((5<<4)+reg,t);break;
	case shr: fputc((6<<4)+reg,t);break;
	case and: fputc((7<<4)+reg,t);break;
	case orr: fputc((8<<4)+reg,t);break;
	case xor: fputc((9<<4)+reg,t);break;
	case add: fputc((10<<4)+reg,t);break;
	case sub: fputc((11<<4)+reg,t);break;
	case cal: fputc((12<<4)+reg,t);break;
	case ret: fputc((13<<4)+reg,t);break;
	case Imv: fputc((14<<4)+reg,t);break;
	case jmp: fputc((15<<4)+reg,t);break;
	default: exit(-1);
	}break;
    case 3:
	switch(inst){
	//Normal instructions
	case mvA: fputc((0<<4)+reg,t);break;
	case coA: fputc((1<<4)+reg,t);break;
	case mvB: fputc((2<<4)+reg,t);break;
	case coB: fputc((3<<4)+reg,t);break;
	case csB: fputc((4<<4)+reg,t);break;
	case shl: fputc((5<<4)+reg,t);break;
	case shr: fputc((6<<4)+reg,t);break;
	case and: fputc((7<<4)+reg,t);break;
	case orr: fputc((8<<4)+reg,t);break;
	case xor: fputc((9<<4)+reg,t);break;
	case add: fputc((10<<4)+reg,t);break;
	case sub: fputc((11<<4)+reg,t);break;
	case iint: fputc((12<<4)+reg,t);break;
	case ire: fputc((13<<4)+reg,t);break;
	case Imv: fputc((14<<4)+reg,t);break;
	case jmp: fputc((15<<4)+reg,t);break;
	default: exit(-1);
	}break;
    default: exit(-1);
    }
    torg++;
//    printf("torg++\n");
}

void getMac(int inst,int reg){
    switch(version){
    case 1:
	break;
    case 2:
	break;
    case 3:switch(inst){//SP:reg $7
	    case cal://SP++, [SP]<-reg
		getInst(Imv,TMPREG1);
		getInst(mvA,TMPREG1);//A=SP
		getInst(coB,13);//length of the macros cal+pus!!!
		getInst(add,TMPREG1);//SP++
		getMac(pus,TMPREG1);
		getInst(coA,1);
		getInst(jmp,reg);//Jump to the location
		break;
	    case ret://SP++, [SP]<-reg
		getMac(pop,TMPREG1);//Pop the address of the return
		getInst(coA,1);
		getInst(jmp,TMPREG1);//Jump to the location
		break;
	    case pus://SP++, [SP]<-reg
		getInst(mvA,SPORIG);//A=SP
		getInst(coB,1);
		getInst(add,SPORIG);//SP++
		getInst(add,DP);//DP=SP
		getInst(coA,0);
		getInst(mvB,reg);//B=reg
		getInst(add,DAT);//[SP]=reg
		break;
	    case pop://[SP]->reg, SP--
		getInst(mvA,SPORIG);//A=SP
		getInst(coB,0);
		getInst(add,DP);//SP->DP,data=top of the stack
		getInst(mvA,DAT);//A=DATA
		getInst(add,TMPREG1);//TMP1=poped data
		getInst(mvA,SPORIG);//A=SP
		getInst(coB,1);
		getInst(sub,SPORIG);//SP--
		getInst(mvA,TMPREG1);//A=poped data
		getInst(coB,0);
		getInst(add,reg);//reg=poped data
		break;
	    case top:
		getInst(mvA,7);//A=SPORIG
		getInst(coB,0);
		getInst(add,DP);//SP->DP,data=top of the stack
		getInst(mvA,DAT);//A= data at top of the stack
		getInst(add,reg);//reg= data at top of the stack
		break;
	    default: exit (-1);
	}
	break;
    }
}

//A cimet betoltjuk DP-be, es a muveletet a mem regiszteren vegezzuk el
void labMac(char *label){
    int addr;
    addr=findlabel(label);
    switch(version){
    case 1:{
	    getInst(coA,0);
	    if(addr!=0){
		getInst(coB,addr & 15);
		getInst(add,TMPREG1);
		
		while(addr!=0){
		    getInst(mvA,TMPREG1);
		    getInst(coB,4);
		    getInst(shl,TMPREG1);
		    getInst(mvA,TMPREG1);
		    getInst(coB,addr&15);
	    	    getInst(add,TMPREG1);
		    addr=addr>>4;
		    }
		getInst(mvA,TMPREG1);
	    }
	    getInst(mvB,DPORIG);
	    getInst(add,TMPREG1);
	    getInst(mvP,TMPREG1);
    }
    case 2:case 3:{
	    getInst(mvA,DPORIG);
	if(addr!=0){
	    getInst(coB,addr & 15);
	    addr=addr>>4;
	    while(addr!=0){
		getInst(csB,addr & 15);
		addr=addr>>4;
	    }
	}
	else{
	    getInst(coB,0);
	}
    getInst(add,DP);//reg=DP
    }
    }
}
